﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Bentley.DgnPlatformNET;
using Bentley.DgnPlatformNET.Elements;
using Bentley.GeometryNET;
using Bentley.MstnPlatformNET;
namespace csAddins
{
    extern alias DDUI;
    public partial class PreviewTools : Form
    {
        public PreviewTools()
        {
            InitializeComponent();
        }

        private void ShowCurrentModelBtn_Click(object sender, EventArgs e)
        {
            //获取当前DgnModel
            DgnModel dgnmodel = Bentley.MstnPlatformNET.Session.Instance.GetActiveDgnModel();
            try
            {
                //构造元素集
                ElementAgenda showElements = new ElementAgenda();
                //元素集来源为选择
                showElements.Source = ModifyElementSource.Selected;
                //获取当前DgnModel所有图形元素
                ModelElementsCollection elements = dgnmodel.GetGraphicElements();
                //遍历所有图形元素
                IEnumerator<Element> allelement = elements.GetEnumerator();
                while (allelement.MoveNext())
                {
                    showElements.Insert(allelement.Current, false);
                }
                //获取当前DgnModel的IntPtr
                IntPtr modelPtr = dgnmodel.GetNative();
                unsafe
                {
                    //构造PreviewControl,注意此处DDUI的使用
                    DDUI.Bentley.DgnPlatform.PreviewControl pc = new DDUI.Bentley.DgnPlatform.PreviewControl((DDUI.Bentley.DgnPlatform.DgnModel*)modelPtr.ToPointer());
                    this.elementHost1.Child = pc;
                    pc.FitToView();
                    pc.Rotate(DDUI.Bentley.DgnPlatform.RotationMode.Isometric);
                    pc.SetRenderMode(DDUI.Bentley.DgnPlatform.RenderMode.Solid);
                    pc.ShowPreview(showElements);
                    pc.Refresh();
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show(ex.Message + ":" + ex.StackTrace);
            }
        }

        private void s(object sender, EventArgs e)
        {

        }
    }
}
