﻿using Bentley.DgnPlatformNET;
using Bentley.DgnPlatformNET.Elements;
using Bentley.CifNET.GeometryModel.SDK;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bentley.MstnPlatformNET;
using Bentley.CifNET.SDK.Edit;
using Bentley.CifNET.GeometryModel.SDK.Edit;
using Bentley.CifNET.SDK;
using Bentley.GeometryNET;
using Bentley.CifNET.LinearGeometry;

namespace csAddins
{
    class createProfile
    {
        
        public static void openProfile(string unparsed)
        {
            DgnModel dgnModel = Session.Instance.GetActiveDgnModel();
            long myid = 1231;
            ElementId elId = new ElementId(ref myid);
            Element ele = dgnModel.GetDgnModel()
                                  .FindElementById(elId);
            if (ele != null)
            {
                ConsensusConnectionEdit con = ConsensusConnectionEdit.GetActive();
                AlignmentEdit al = (Alignment.CreateFromElement(con, ele)) as AlignmentEdit;
    
                DPoint3d[] points = { new DPoint3d(100, 100), new DPoint3d(600, 110), new DPoint3d(1000, 105) };
                
                ProfileElement element = ProfileElement.Create1(450.0, 750.0, points);
                if (element != null)
                {
                    con.StartTransientMode();
                    ProfileEdit edit = ProfileEdit.CreateByProfileElement(con, al, element, true, false); 
                    con.PersistTransients();
                    al.SetActiveProfile(edit);
                }
            }
        }

    }
}
